import csv
from random import *

pays = []
score = 0

with open('countries.csv', newline='') as csvfile:
    spamreader = csv.DictReader(csvfile, delimiter=';')
    for row in spamreader:
        pays.append(dict(row))

def jeu_capitale(p,s):
    x = randint(0,len(p)-1)
    question="Quelle est la capitale du " + p[x]['name'] + " ?"
    print(question)
    r=input(question)
    if r==p[x]['capital']:
        s+=1
        print("Vous avez répondu", r, "- Bravo, c'est la bonne réponse")
    else:
        print("Vous avez répondu", r, "- C'est faux, c'était", p[x]['capital'])
    return r,s

def approche(n):
    for i in range (15):
        if 20*(10**i)<=n<20*(10**(i+1)):
            return 10**(i+1)

def jeu_population(p,s):
    x = randint(0,len(p)-1)
    approx=approche(int(p[x]['population']))
    question="Quel est le nombre d'habitant de " + p[x]['name'] +" à "+ str(approx) + " près ?"
    print(question)
    r=input(question)
    if r!='Quitter':
        r=int(r)
    else:
        return r,s
    if abs(int(p[x]['population'])-r)<approx:
        s+=1
        print("Vous avez répondu", r, "- Bravo, la population est de ", p[x]['population'], "- Votre score est de", s)
    else:
        print("Vous avez répondu", r, "- C'est faux, la population est de", p[x]['population'], "- Votre score est de", s)
    return r,s

def clé_superficie(p):
    return float(p['area'])

def jeu_rang_area(p,s):
    classement=[i for i in sorted(p, key = lambda x : float(x['area']))]
##    classement=[i for i in sorted(p, key = clé_superficie)]
    x = randint(0,len(p)-1)
    question="Quel est le rang de " + classement[x]['name'] + " sur un classement de la plus petite à la plus grande surface (à 6 places près) ?"
    print(question)
    r=input(question)
    if r!='Quitter':
        r=int(r)
    else:
        return r,s
    if abs(x-r)<6:
        s+=1
        print("Vous avez répondu", r, "- Bravo, le pays est au rang", x,"- Votre score est de", s)
    else:
        print("Vous avez répondu", r, "- C'est faux, le rang de ce pays était ", x,"- Votre score est de", s)
    return r,s

continuer = True
while continuer == True :
    choix=0
    print("Quel jeu voulez-vous choisir ?")
    print("1 - Jeu des capitales")
    print("2 - Jeu de la population")
    print("3 - Jeu du classement par surface")
    choix=input()
    if choix!='Quitter':
        choix=int(choix)
    if choix==1:
        reponse,score=jeu_capitale(pays,score)
    elif choix==2:
        reponse,score=jeu_population(pays,score)
    elif choix==3:
        reponse,score=jeu_rang_area(pays,score)
    elif choix=="Quitter":
        print("A bientôt")
    else :
        print("Choix non valide !")
    if choix=="Quitter" or reponse=="Quitter":
        continuer=False
    print("Votre score est de", score)